=== debian/changelog ===
qt6-qml-pdwidgets1 (1.0.1.g9354cb2-0+23.5) UNRELEASED; urgency=medium

  * version number update by debtransform

 -- debtransform <build@opensuse.org>  Sun, 20 Jul 2025 05:41:41 +0000

qt6-qml-pdwidgets1 (1.0.1.g9354cb2-0) UNRELEASED; urgency=medium

   * Initial, First build

 -- Bjarne von Horn <vh@igh.de>  Mon, 24 Jan 2022 16:14:57 +0100
