=== debian/control ===
Source: qt6-qml-pdwidgets1
Priority: optional
Maintainer: Andreas Stewering-Bone <ab@igh.de>
Build-Depends: dh-exec (>= 0.3), debhelper (>= 9), qtchooser, qt6-base-dev, qt6-charts-dev, qt6-svg-dev, qt6-tools-dev, libqt6pdcom1-dev, cmake (>= 3.18), qt6-declarative-dev, qml6-module-qtpcom1-dev
Standards-Version: 3.9.5
Section: libs
Homepage: http://www.etherlab.org

Package: libqt6-qml-pdwidgets1-dev
Section: libdevel
Architecture: any
Depends: libqt6-qml-pdwidgets1-1 (= ${binary:Version}), libqt6pdcom1-dev, ${misc:Depends}
Description: Process data widgets for QML
 This is a bundle of QML-based process data widgets for Qt6. It uses the PdCom library to
 access the actual process variables and it includes a plugin for the Qt
 Designer. See http://etherlab.org/en/pdwidgets for more information.
 .
 Header files

Package: libqt6-qml-pdwidgets1-1
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, qml6-module-qtpcom1
Description: Process data widgets for QML
 This is a bundle of QML-based process data widgets for Qt6. It uses the PdCom library to
 access the actual process variables and it includes a plugin for the Qt
 Designer. See http://etherlab.org/en/pdwidgets for more information.

Package: pdserv-example-qmlviewer-qt6
Section: misc
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libqt6-qml-pdwidgets1-1 (>= ${binary:Version}), qml6-module-qtquick-controls, qml6-module-qtquick-dialogs, qml6-module-qtquick-templates, qml6-module-qtquick-window, qml6-module-qtqml-workerscript, qml6-module-qtquick-layouts, qml6-module-qtqml, qml6-module-qtcharts
Suggests: libpdserv3-example
Description: Qml-based Gui for pdserv-example
 Gui which demonstrates how many of the QML-based process data widgets work.
 It is designed to interact with the oscillator demo provided by
 libpdserv3-example.
